<template>
  <n-space vertical>
    <n-layout has-sider>
      <n-layout-sider bordered collapse-mode="width" :collapsed-width="64" :width="240" :collapsed="collapsed"
        show-trigger @collapse="collapsed = true" @expand="collapsed = false" style="min-height: 100vh;">
        <n-menu v-model:value="activeKey" :collapsed="collapsed" :collapsed-width="64" :collapsed-icon-size="22"
          :options="menuOptions" />
      </n-layout-sider>
      <n-layout>
        <n-card class="main">
          <Suspense>
            <RouterView></RouterView>
          </Suspense>
        </n-card>
      </n-layout>
    </n-layout>
  </n-space>
</template>
  
<script lang="ts">
import { defineComponent, h, ref, Component } from 'vue'
import { NIcon, NSpace, NMenu, NLayout, NLayoutSider, NCard } from 'naive-ui'
import type { MenuOption } from 'naive-ui'
import { RouterLink, RouterView } from 'vue-router'
import {
  LockOpenOutline as LockIcon,
  SquareOutline as SquareIcon,
  PencilOutline as PencilIcon,
  CopyOutline as CardIcon,
  PaperPlaneOutline as PaperIcon,
  AddOutline as AddIcon
} from '@vicons/ionicons5'

function renderIcon(icon: Component) {
  return () => h(NIcon, null, { default: () => h(icon) })
}


const menuOptions: MenuOption[] = [
  {
    label: () =>
      h(
        RouterLink,
        {
          to: {
            name: 'login',
          }
        },
        { default: () => 'Login' }
      ),
    key: 'login',
    icon: renderIcon(LockIcon)
  },
  {
    icon: renderIcon(AddIcon),
    key: 'add',
    label: 'Add',
    children: [
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'editor',
              }
            },
            { default: () => 'Add Card' }
          ), key: 'add_card',
        icon: renderIcon(SquareIcon)
      },
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'deck',
              }
            },
            { default: () => 'Add Deck' }
          ), key: 'add_deck',
        icon: renderIcon(CardIcon)
      },
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'course',
              }
            },
            { default: () => 'Add Course' }
          ), key: 'add_course',
        icon: renderIcon(PaperIcon)
      }
    ]
  },

  {
    icon: renderIcon(PencilIcon),
    key: 'edit',
    label: 'Edit',
    children: [
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'card_edit',
              }
            },
            { default: () => 'Edit Cards' }
          ), key: 'card_edit',
        icon: renderIcon(SquareIcon)
      },
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'deck_edit',
              }
            },
            { default: () => 'Edit Decks' }
          ), key: 'deck_edit',
        icon: renderIcon(CardIcon)
      },
      {
        label: () =>
          h(
            RouterLink,
            {
              to: {
                name: 'course_edit',
              }
            },
            { default: () => 'Edit Courses' }
          ), key: 'course_edit',
        icon: renderIcon(PaperIcon)
      }
    ]
  },
]

export default defineComponent({
  setup() {
    return {
      activeKey: ref<string | null>(null),
      collapsed: ref(true),
      menuOptions
    }
  },
  components: {
    NSpace,
    NMenu,
    NLayout,
    NLayoutSider,
    NCard
  }
})
</script>